diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryUndyeing.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryUndyeing.java
new file mode 100644
index 000000000..31b322fbd
--- /dev/null
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryUndyeing.java
@@ -0,0 +1,157 @@
+package net.minecraft.core.data.registry.recipe.entry;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.data.registry.recipe.HasJsonAdapter;
+import net.minecraft.core.data.registry.recipe.RecipeGroup;
+import net.minecraft.core.data.registry.recipe.RecipeNamespace;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.SearchQuery;
+import net.minecraft.core.data.registry.recipe.adapter.RecipeEntryUndyeingJsonAdapter;
+import net.minecraft.core.data.registry.recipe.adapter.RecipeJsonAdapter;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.player.inventory.container.CraftingContainer;
+
+import java.util.List;
+import java.util.Objects;
+
+public class RecipeEntryUndyeing extends RecipeEntryCraftingDynamic implements HasJsonAdapter {
+    public RecipeSymbol inputSymbol;
+    public ItemStack output;
+    public RecipeEntryUndyeing() {
+        
+    }
+
+    public RecipeEntryUndyeing(RecipeSymbol input, ItemStack output) {
+        this.inputSymbol = input;
+        this.output = output;
+    }
+
+    @Override
+    public boolean matches(CraftingContainer craftingContainer) {
+        if (craftingContainer.getContainerSize() < 9) return false;
+        for (int i = 0; i < 9; i++) {
+            if (i == 4) {
+                ItemStack stack = craftingContainer.getItem(i);
+                if (stack == null || stack.getItem() != Blocks.SPONGE_WET.asItem()) {
+                    return false;
+                }
+            } else {
+               if (!inputSymbol.matches(craftingContainer.getItem(i))) {
+                   return false;
+               }
+            }
+        }
+        return true;
+    }
+
+    @Override
+    public boolean matchesQuery(SearchQuery query) {
+        switch (query.mode){
+            case ALL: {
+                if ((matchesRecipe(query) || matchesUsage(query)) && matchesScope(query)) return true;
+                break;
+            }
+            case RECIPE: {
+                if (matchesRecipe(query) && matchesScope(query)) return true;
+                break;
+            }
+            case USAGE: {
+                if (matchesUsage(query) && matchesScope(query)) return true;
+                break;
+            }
+        }
+        return false;
+    }
+
+    public boolean matchesScope(SearchQuery query){
+        if(query.scope.getLeft() == SearchQuery.SearchScope.NONE) return true;
+        if(query.scope.getLeft() == SearchQuery.SearchScope.NAMESPACE) {
+            RecipeNamespace namespace = Registries.RECIPES.getItem(query.scope.getRight());
+            if(namespace == parent.getParent()){
+                return true;
+            }
+        } else if (query.scope.getLeft() == SearchQuery.SearchScope.NAMESPACE_GROUP) {
+            RecipeGroup group;
+            try {
+                group = Registries.RECIPES.getGroupFromKey(query.scope.getRight());
+            } catch (IllegalArgumentException e){
+                group = null;
+            }
+            if(group == parent){
+                return true;
+            }
+        }
+        return false;
+    }
+
+    public boolean matchesRecipe(SearchQuery query) {
+        if(query.query.getLeft() == SearchQuery.QueryType.NAME) {
+            if(query.strict && output.getDisplayName().equalsIgnoreCase(query.query.getRight())){
+                return true;
+            } else if(!query.strict && output.getDisplayName().toLowerCase().contains(query.query.getRight().toLowerCase())){
+                return true;
+            }
+        } else if (query.query.getLeft() == SearchQuery.QueryType.GROUP && !Objects.equals(query.query.getRight(), "")) {
+            List<ItemStack> groupStacks = new RecipeSymbol(query.query.getRight()).resolve();
+            if(groupStacks == null) return false;
+            return groupStacks.contains(output);
+        }
+        return false;
+    }
+
+    public boolean matchesUsage(SearchQuery query) {
+        RecipeSymbol[] symbols = {inputSymbol, new RecipeSymbol(Blocks.SPONGE_WET.getDefaultStack())};
+        for (RecipeSymbol symbol : symbols) {
+            if(symbol == null) continue;
+            List<ItemStack> stacks = symbol.resolve();
+            if(query.query.getLeft() == SearchQuery.QueryType.NAME) {
+                for (ItemStack stack : stacks) {
+                    if(query.strict && stack.getDisplayName().equalsIgnoreCase(query.query.getRight())){
+                        return true;
+                    } else if (!query.strict && stack.getDisplayName().toLowerCase().contains(query.query.getRight().toLowerCase())) {
+                        return true;
+                    }
+                }
+            } else if (query.query.getLeft() == SearchQuery.QueryType.GROUP && !Objects.equals(query.query.getRight(), "")) {
+                List<ItemStack> groupStacks = new RecipeSymbol(query.query.getRight()).resolve();
+                if(groupStacks == null) return false;
+                if(stacks.stream().anyMatch((groupStacks::contains))){
+                    return true;
+                }
+            }
+
+        }
+        return false;
+    }
+
+    @Override
+    public ItemStack getCraftingResult(CraftingContainer craftingContainer) {
+        return new ItemStack(output);
+    }
+
+    @Override
+    public int getRecipeSize() {
+        return 9;
+    }
+
+    @Override
+    public ItemStack[] onCraftResult(CraftingContainer craftingContainer) {
+        ItemStack[] returnStack = new ItemStack[9];
+        for (int i = 0; i < craftingContainer.getContainerSize(); i++) {
+            ItemStack itemstack1 = craftingContainer.getItem(i);
+            if (itemstack1 == null) {
+                continue;
+            }
+            if (i != 4) {
+                craftingContainer.removeItem(i, 1);
+            }
+        }
+        return returnStack;
+    }
+
+    @Override
+    public RecipeJsonAdapter<?> getAdapter() {
+        return new RecipeEntryUndyeingJsonAdapter();
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/World.java b/src/main/java/net/minecraft/core/world/World.java
index be9cae290..fc277ad9d 100644
--- a/src/main/java/net/minecraft/core/world/World.java
+++ b/src/main/java/net/minecraft/core/world/World.java
@@ -1869,14 +1869,13 @@ public class World implements WorldSource {
         }
 
         updatingBlockEntities = true;
-        Iterator<BlockEntity> iterator = loadedBlockEntityList.iterator();
-        while (iterator.hasNext()) {
-            BlockEntity blockEntity = iterator.next();
+        for (int i = loadedBlockEntityList.size() - 1; i >= 0; i--) {
+            BlockEntity blockEntity = loadedBlockEntityList.get(i);
             if (!blockEntity.isInvalid() && isBlockLoaded(blockEntity.x, blockEntity.y, blockEntity.z)) {
                 blockEntity.tick();
             }
-            if (blockEntity.isInvalid()) {
-                iterator.remove();
+            if (blockEntity.isInvalid() && blockEntity == getBlockEntity(blockEntity.x, blockEntity.y, blockEntity.z)) {
+                loadedBlockEntityList.remove(i);
                 Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(blockEntity.x, Chunk.CHUNK_SIZE_X), Math.floorDiv(blockEntity.z, Chunk.CHUNK_SIZE_Z));
                 if (chunk != null) {
                     chunk.removeBlockEntity(blockEntity.x & (Chunk.CHUNK_SIZE_X - 1), blockEntity.y, blockEntity.z & (Chunk.CHUNK_SIZE_Z - 1));
@@ -1884,35 +1883,11 @@ public class World implements WorldSource {
             }
         }
         updatingBlockEntities = false;
-        if(!queuedBlockEntityAdditions.isEmpty())
-        {
-            Iterator<BlockEntity> entityIterator = queuedBlockEntityAdditions.iterator();
-            while (entityIterator.hasNext()) {
-                BlockEntity blockEntity = entityIterator.next();
-                if (!blockEntity.isInvalid()) {
-                    if (!loadedBlockEntityList.contains(blockEntity)) {
-                        loadedBlockEntityList.add(blockEntity);
-                    }
-                    Chunk chunk1 = getChunkFromChunkCoords(Math.floorDiv(blockEntity.x, Chunk.CHUNK_SIZE_X), Math.floorDiv(blockEntity.z, Chunk.CHUNK_SIZE_Z));
-                    if (chunk1 != null) {
-                        chunk1.setBlockEntity(blockEntity.x & (Chunk.CHUNK_SIZE_X - 1), blockEntity.y, blockEntity.z & (Chunk.CHUNK_SIZE_Z - 1), blockEntity);
-                    }
-                    markBlockNeedsUpdate(blockEntity.x, blockEntity.y, blockEntity.z);
-                }
-            }
-            queuedBlockEntityAdditions.clear();
-        }
     }
 
     public void addAllBlockEntities(Collection<BlockEntity> blockEntities)
     {
-        if(updatingBlockEntities)
-        {
-            queuedBlockEntityAdditions.addAll(blockEntities);
-        } else
-        {
-            loadedBlockEntityList.addAll(blockEntities);
-        }
+        loadedBlockEntityList.addAll(blockEntities);
     }
 
     public void updateEntity(Entity entity)
@@ -2290,20 +2265,11 @@ public class World implements WorldSource {
     {
         if(!tileentity.isInvalid())
         {
-            if(updatingBlockEntities)
-            {
-                tileentity.x = i;
-                tileentity.y = j;
-                tileentity.z = k;
-                queuedBlockEntityAdditions.add(tileentity);
-            } else
+            loadedBlockEntityList.add(tileentity);
+            Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(i, Chunk.CHUNK_SIZE_X), Math.floorDiv(k, Chunk.CHUNK_SIZE_Z));
+            if(chunk != null)
             {
-                loadedBlockEntityList.add(tileentity);
-                Chunk chunk = getChunkFromChunkCoords(Math.floorDiv(i, Chunk.CHUNK_SIZE_X), Math.floorDiv(k, Chunk.CHUNK_SIZE_Z));
-                if(chunk != null)
-                {
-                    chunk.setBlockEntity(i & (Chunk.CHUNK_SIZE_X - 1), j, k & (Chunk.CHUNK_SIZE_Z - 1), tileentity);
-                }
+                chunk.setBlockEntity(i & (Chunk.CHUNK_SIZE_X - 1), j, k & (Chunk.CHUNK_SIZE_Z - 1), tileentity);
             }
         }
     }
@@ -2329,6 +2295,11 @@ public class World implements WorldSource {
         }
     }
 
+    public void replaceBlockTileEntity(int i, int j, int k, BlockEntity tileentity) {
+        removeBlockTileEntity(i, j, k);
+        setBlockTileEntity(i, j, k, tileentity);
+    }
+
     @Override
     public boolean isBlockOpaqueCube(int x, int y, int z)
     {
diff --git a/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index e6b4d617d..4a8272092 100644
--- a/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -521,6 +521,7 @@ public class Chunk
         if (getBlockID(x, y, z) == 0 || !(Block.blocksList[getBlockID(x, y, z)] instanceof EntityBlock))
         {
             LOGGER.warn("Attempted to place a tile entity where there was no entity tile!");
+            Thread.dumpStack();
         }
         else
         {
diff --git a/src/main/java/net/minecraft/datagen/RecipesGenerator.java b/src/main/java/net/minecraft/datagen/RecipesGenerator.java
new file mode 100644
index 000000000..c5cbd2fc2
--- /dev/null
+++ b/src/main/java/net/minecraft/datagen/RecipesGenerator.java
@@ -0,0 +1,113 @@
+package net.minecraft.datagen;
+
+import com.google.gson.JsonArray;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonParser;
+import com.google.gson.stream.JsonReader;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.data.registry.recipe.RecipeGroup;
+import net.minecraft.core.item.Items;
+import net.minecraft.datagen.recipeBuilders.RecipeBuilder;
+
+import java.io.File;
+import java.io.FileReader;
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.List;
+
+public class RecipesGenerator {
+    private static final boolean DEBUG = false;
+    public static final String CORE_NAMESPACE = "minecraft";
+    public static void main(String[] args) {
+        Blocks.init();
+        Items.init();
+        new Registries();
+
+        List<String> remainingEntries;
+
+        WorkbenchGenerator.generate();
+        if (DEBUG) {
+            remainingEntries = getMissingIds(Registries.RECIPES.WORKBENCH, new File("src/common/resources/recipes/workbench.json"));
+            if (remainingEntries.isEmpty()) {
+                System.out.println("Workbench contains all reference entries!");
+            } else {
+                remainingEntries.sort(String::compareTo);
+                System.out.println("Workbench is missing " + remainingEntries.size() + " entries!");
+                for (String s : remainingEntries) {
+                    System.out.println(s);
+                }
+            }
+        }
+        RecipeBuilder.exportRecipes(new File("generated/recipes/workbench.json"), Registries.RECIPES.WORKBENCH);
+
+        if (DEBUG) System.out.println();
+
+        SmeltingGenerator.generate();
+        if (DEBUG) {
+            remainingEntries = getMissingIds(Registries.RECIPES.FURNACE, new File("src/common/resources/recipes/furnace.json"));
+            if (remainingEntries.isEmpty()) {
+                System.out.println("Furnace contains all reference entries!");
+            } else {
+                remainingEntries.sort(String::compareTo);
+                System.out.println("Furnace is missing " + remainingEntries.size() + " entries!");
+                for (String s : remainingEntries) {
+                    System.out.println(s);
+                }
+            }
+        }
+        RecipeBuilder.exportRecipes(new File("generated/recipes/furnace.json"), Registries.RECIPES.FURNACE);
+
+        if (DEBUG) System.out.println();
+
+        if (DEBUG) {
+            remainingEntries = getMissingIds(Registries.RECIPES.BLAST_FURNACE, new File("src/common/resources/recipes/blast_furnace.json"));
+            if (remainingEntries.isEmpty()) {
+                System.out.println("Blast furnace contains all reference entries!");
+            } else {
+                remainingEntries.sort(String::compareTo);
+                System.out.println("Blast furnace is missing " + remainingEntries.size() + " entries!");
+                for (String s : remainingEntries) {
+                    System.out.println(s);
+                }
+            }
+        }
+        RecipeBuilder.exportRecipes(new File("generated/recipes/blast_furnace.json"), Registries.RECIPES.BLAST_FURNACE);
+
+        if (DEBUG) System.out.println();
+
+        TrommelGenerator.generate();
+        if (DEBUG) {
+            remainingEntries = getMissingIds(Registries.RECIPES.TROMMEL, new File("src/common/resources/recipes/trommel.json"));
+            if (remainingEntries.isEmpty()) {
+                System.out.println("Trommel contains all reference entries!");
+            } else {
+                remainingEntries.sort(String::compareTo);
+                System.out.println("Trommel is missing " + remainingEntries.size() + " entries!");
+                for (String s : remainingEntries) {
+                    System.out.println(s);
+                }
+            }
+        }
+        RecipeBuilder.exportRecipes(new File("generated/recipes/trommel.json"), Registries.RECIPES.TROMMEL);
+    }
+
+    public static List<String> getMissingIds(RecipeGroup recipeGroup, File referenceFile) {
+        assert referenceFile != null;
+        assert referenceFile.isFile();
+        assert referenceFile.exists();
+        try {
+            JsonArray entries = JsonParser.parseReader(new JsonReader(new FileReader(referenceFile))).getAsJsonArray();
+            List<String> entryNames = new ArrayList<>();
+            for (JsonElement e : entries) {
+                entryNames.add(e.getAsJsonObject().get("name").getAsString().replaceFirst("minecraft:" + recipeGroup.getParent().getKey(recipeGroup) + "/", ""));
+            }
+            for (Object recipe : recipeGroup) {
+                entryNames.remove(recipeGroup.getKey(recipe));
+            }
+            return entryNames;
+        } catch (IOException e) {
+            throw new RuntimeException(e);
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/datagen/SmeltingGenerator.java b/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
new file mode 100644
index 000000000..e3c361dfd
--- /dev/null
+++ b/src/main/java/net/minecraft/datagen/SmeltingGenerator.java
@@ -0,0 +1,75 @@
+package net.minecraft.datagen;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.datagen.recipeBuilders.RecipeBuilder;
+
+import static net.minecraft.datagen.RecipesGenerator.CORE_NAMESPACE;
+
+public class SmeltingGenerator {
+    public static void generate() {
+        sharedRecipe("block_sugarcane_to_block_sugarcane_baked", Blocks.BLOCK_SUGARCANE.getDefaultStack(), Blocks.BLOCK_SUGARCANE_BAKED.getDefaultStack());
+        sharedRecipe("cactus_to_cactus_green", Blocks.CACTUS.getDefaultStack(), new ItemStack(Items.DYE, 1, DyeColor.GREEN.itemMeta));
+        sharedRecipe("clay_to_brick_clay", Items.CLAY.getDefaultStack(), Items.BRICK_CLAY.getDefaultStack());
+        sharedRecipe("mud_to_baked_mud", Blocks.MUD.getDefaultStack(), Blocks.MUD_BAKED.getDefaultStack());
+        sharedRecipe("logs_to_charcoal", "minecraft:logs", new ItemStack(Items.COAL, 1, 1));
+        sharedRecipe("sand_to_glass", Blocks.SAND.getDefaultStack(), Blocks.GLASS.getDefaultStack());
+        sharedRecipe("sponge_wet_to_sponge_dry", Blocks.SPONGE_WET.getDefaultStack(), Blocks.SPONGE_DRY.getDefaultStack());
+
+        sharedRecipe("coal_ores_to_coal", "minecraft:coal_ores", Items.COAL.getDefaultStack());
+        sharedRecipe("diamond_ores_to_diamond", "minecraft:diamond_ores", Items.DIAMOND.getDefaultStack());
+        sharedRecipe("gold_ores_to_gold_ingot", "minecraft:gold_ores", Items.INGOT_GOLD.getDefaultStack());
+        sharedRecipe("iron_ores_to_iron_ingot", "minecraft:iron_ores", Items.INGOT_IRON.getDefaultStack());
+        sharedRecipe("lapis_ores_to_lapis_lazuli", "minecraft:lapis_ores", new ItemStack(Items.DYE, 1, DyeColor.BLUE.itemMeta));
+        sharedRecipe("redstone_ores_to_redstone_dust", "minecraft:redstone_ores", Items.DUST_REDSTONE.getDefaultStack());
+        sharedRecipe("nethercoal_ores_to_nethercoal", "minecraft:nethercoal_ores", Items.NETHERCOAL.getDefaultStack());
+
+        sharedRecipe("raw_iron_to_iron_ingot", Items.ORE_RAW_IRON.getDefaultStack(), Items.INGOT_IRON.getDefaultStack());
+        sharedRecipe("raw_gold_to_gold_ingot", Items.ORE_RAW_GOLD.getDefaultStack(), Items.INGOT_GOLD.getDefaultStack());
+
+        furnaceRecipe("fish_raw_to_fish_cooked", Items.FOOD_FISH_RAW.getDefaultStack(), Items.FOOD_FISH_COOKED.getDefaultStack());
+        furnaceRecipe("porkchop_raw_to_porkchop_cooked", Items.FOOD_PORKCHOP_RAW.getDefaultStack(), Items.FOOD_PORKCHOP_COOKED.getDefaultStack());
+
+        furnaceRecipe("cobble_stone_to_stone", Blocks.COBBLE_STONE.getDefaultStack(), Blocks.STONE.getDefaultStack());
+        furnaceRecipe("cobble_basalt_to_basalt", Blocks.COBBLE_BASALT.getDefaultStack(), Blocks.BASALT.getDefaultStack());
+        furnaceRecipe("cobble_granite_to_granite", Blocks.COBBLE_GRANITE.getDefaultStack(), Blocks.GRANITE.getDefaultStack());
+        furnaceRecipe("cobble_limestone_to_limestone", Blocks.COBBLE_LIMESTONE.getDefaultStack(), Blocks.LIMESTONE.getDefaultStack());
+        furnaceRecipe("cobble_netherrack_to_netherrack", Blocks.COBBLE_NETHERRACK.getDefaultStack(), Blocks.NETHERRACK.getDefaultStack());
+        furnaceRecipe("cobble_permafrost_to_permafrost", Blocks.COBBLE_PERMAFROST.getDefaultStack(), Blocks.PERMAFROST.getDefaultStack());
+
+        blastRecipe("cobble_basalt_to_olivine", Blocks.COBBLE_BASALT.getDefaultStack(), Items.OLIVINE.getDefaultStack());
+        blastRecipe("cobble_granite_to_quartz", Blocks.COBBLE_GRANITE.getDefaultStack(), Items.QUARTZ.getDefaultStack());
+        blastRecipe("cobble_limestone_to_marble", Blocks.COBBLE_LIMESTONE.getDefaultStack(), Blocks.MARBLE.getDefaultStack());
+        blastRecipe("cobble_permafrost_to_permafrost", Blocks.COBBLE_PERMAFROST.getDefaultStack(), Blocks.PERMAFROST.getDefaultStack());
+        blastRecipe("cobble_stone_to_slate", Blocks.COBBLE_STONE.getDefaultStack(), Blocks.SLATE.getDefaultStack());
+        blastRecipe("iron_ingot_to_crude_steel", Items.INGOT_IRON.getDefaultStack(), Items.INGOT_STEEL_CRUDE.getDefaultStack());
+    }
+
+    private static void furnaceRecipe(String id, ItemStack input, ItemStack output) {
+        RecipeBuilder.Furnace(CORE_NAMESPACE).setInput(input).create(id, output);
+    }
+
+    private static void furnaceRecipe(String id, String inputGroup, ItemStack output) {
+        RecipeBuilder.Furnace(CORE_NAMESPACE).setInput(inputGroup).create(id, output);
+    }
+
+    private static void blastRecipe(String id, ItemStack input, ItemStack output) {
+        RecipeBuilder.BlastFurnace(CORE_NAMESPACE).setInput(input).create(id, output);
+    }
+
+    private static void blastRecipe(String id, String inputGroup, ItemStack output) {
+        RecipeBuilder.BlastFurnace(CORE_NAMESPACE).setInput(inputGroup).create(id, output);
+    }
+
+    private static void sharedRecipe(String id, ItemStack input, ItemStack output) {
+        furnaceRecipe(id, input, output);
+        blastRecipe(id, input, output);
+    }
+
+    private static void sharedRecipe(String id, String inputGroup, ItemStack output) {
+        furnaceRecipe(id, inputGroup, output);
+        blastRecipe(id, inputGroup, output);
+    }
+}
diff --git a/src/main/java/net/minecraft/datagen/TrommelGenerator.java b/src/main/java/net/minecraft/datagen/TrommelGenerator.java
new file mode 100644
index 000000000..c2602e718
--- /dev/null
+++ b/src/main/java/net/minecraft/datagen/TrommelGenerator.java
@@ -0,0 +1,78 @@
+package net.minecraft.datagen;
+
+import net.minecraft.core.WeightedRandomLootObject;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.datagen.recipeBuilders.RecipeBuilder;
+
+import static net.minecraft.datagen.RecipesGenerator.CORE_NAMESPACE;
+
+public class TrommelGenerator {
+    public static void generate() {
+        RecipeBuilder.Trommel(CORE_NAMESPACE)
+            .setInput(Blocks.BLOCK_CLAY)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.CLAY), 4, 8), 30)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.AMMO_PEBBLE), 1, 3), 20)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.SULPHUR), 1), 10)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_GOLD), 1), 1)
+            .create("clay");
+
+        RecipeBuilder.Trommel(CORE_NAMESPACE)
+            .setInput("minecraft:trommel_dirt")
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.AMMO_PEBBLE), 1, 3), 50)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.CLAY), 1, 5), 20)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.FLINT), 1, 3), 10)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.SULPHUR), 1), 2)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_IRON), 1), 0.5)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.OLIVINE), 1), 0.25)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.QUARTZ), 1), 0.25)
+            .create("dirt");
+
+        RecipeBuilder.Trommel(CORE_NAMESPACE)
+            .setInput(Blocks.GRAVEL)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.FLINT), 1, 2), 25)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.OLIVINE), 1, 3), 30)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.AMMO_PEBBLE), 1, 6), 25)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_IRON), 1, 2), 10)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.DYE,1, DyeColor.BLUE.itemMeta), 2, 6), 5)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.SULPHUR), 1), 5)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.QUARTZ), 1), 0.5)
+            .create("gravel");
+
+        RecipeBuilder.Trommel(CORE_NAMESPACE)
+            .setInput(Blocks.DIRT_SCORCHED_RICH)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_GOLD), 1), 10)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_IRON), 1, 2), 15)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.QUARTZ), 1, 4), 25)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.OLIVINE), 1, 4), 25)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.DYE,1, DyeColor.BLUE.itemMeta), 2, 4), 20)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.CLAY), 4, 8), 10)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.AMMO_PEBBLE), 1, 5), 5)
+            .create("rich_dirt");
+
+        RecipeBuilder.Trommel(CORE_NAMESPACE)
+            .setInput(Blocks.SAND)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.QUARTZ), 1, 3), 50)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.CLAY), 4, 8), 30)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.AMMO_PEBBLE), 1, 5), 25)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.BONE), 1, 3), 10)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.FLINT), 1, 3), 10)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.SULPHUR), 1), 5)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.OLIVINE), 1), 5)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_GOLD), 1), 1)
+            .create("sand");
+
+        RecipeBuilder.Trommel(CORE_NAMESPACE)
+            .setInput(Blocks.SOULSAND)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.FLINT), 1, 3), 20)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.BONE), 1, 6), 10)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_GOLD), 1), 2)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.ORE_RAW_IRON), 1), 1)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.DUST_GLOWSTONE), 1, 6), 5)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.QUARTZ), 1, 3), 5)
+            .addEntry(new WeightedRandomLootObject(new ItemStack(Items.NETHERCOAL), 1), 0.5)
+            .create("soul_sand");
+    }
+}
